/* cc2y4m.h - some global declarations and macros
 *
 * Copyright (C) 2003 Rik Snel <snel@phys.uu.nl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; only version 2 of the License, not
 * any other version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
 *
 * $Id: cc2y4m.h 59 2004-07-30 21:47:15Z rsnel $
 */
#ifndef INCLUDE_CC2Y4M_H
#define INCLUDE_CC2Y4M_H 1

#include "lock.h"

#define DEBUG(...) if (debug) fprintf(stderr, "debug: " __VA_ARGS__)
#define VERBOSE(...) if (!quiet) fprintf(stderr, __VA_ARGS__)
#define ERROR(...) fprintf(stderr, "error: " __VA_ARGS__)
#define FATAL(...) do { \
	fprintf(stderr, "fatal: " __VA_ARGS__); \
	exit(1); \
} while (0)

extern int debug; 
extern int quiet;

/* Detection methods */


typedef int (*refpoint_t)(lock_t *, unsigned char *, int, int);

struct lock_poldetect {
	int polx;
	int poly;
	int poltresh;
	int polnorm;
	int bright_adjust;
	int filter;
	int center;
	refpoint_t refpoint;
	int locktresh;
};

struct channel_s {
        char *name;
        long freq;
        struct lock_poldetect p;
        struct channel_s *next;
        struct channel_s *prev;
};

extern const struct lock_poldetect *method;

#endif /* INCLUDE_CC2Y4M_H */
