/* The original was distributed as part of cabletv-1.3.9, which is under 
 * the GPL, so this file also... 
 *
 * Trivial changes by Rik Snel and RB in 2004 
 * See http://cube.dyndns.org/svn/cc2y4m for the exact changes */
/*
 *	PAL software decoder (MMX optimized!!!)
 *	includes Y/C separation and YCrCb to RGB conversion
 *
 *	Copyright (C) 1999, Ewald Snel
 *
 *WWW		http://esnel.op.het.net/
 *e-mail	esnel@cistron.nl
 */

#include <stdlib.h>
#include <math.h>
#include "esnelmDecode.h"
#include "cc2y4m.h"
int _cb_width = 0;
int getColorBurstWidth() { return _cb_width; }

	
int brightness = 37;
int contrast = 174;
int saturation = 245;
int correct_brightness = 0;

int adjust_luma_level = 0;
int invert_chroma = 0;
int invert_polarity = 0;

int64 fw384 = MAKEQW( 384 / 4 );

unsigned char scanLuma[decWidth];
char scanCbU[decWidth/2], scanCrV[decWidth/2];
int cosint[1024];

int64 cosin64[1024], prevScan[384];

int64 csc_CbU	= MAKEQW( FIX64( 2.031 ) );
int64 csc_CrV	= MAKEQW( FIX64( 1.141 ) );
int64 csc_CgU	= MAKEQW( FIX64( 0.391 ) );
int64 csc_CgV	= MAKEQW( FIX64( 0.578 ) );
int64 csc_LcY	= MAKEQW( FIX64( 1.164 ) );
int64 csc_clpR	= MAKEQW( ( 49152 - 16 * FIX64( 1.164 ) - 128 * FIX64( 1.141 ) ) );
int64 csc_clpG	= MAKEQW( ( 16384 - 16 * FIX64( 1.164 ) + 128 * ( FIX64( 0.391 ) + FIX64( 0.578 ) ) ) );
int64 csc_clpB	= MAKEQW( ( 49152 - 16 * FIX64( 1.164 ) - 128 * FIX64( 2.031 ) ) );
int64 csc_lvlR	= MAKEQW( 49152 );
int64 csc_lvlG	= MAKEQW( 16384 );
int64 csc_lvlB	= MAKEQW( 49152 );
int64 csc_subR	= MAKEQW( ( 16 * FIX64( 1.164 ) + 128 * FIX64( 1.141 ) ) );
int64 csc_addG	= MAKEQW( ( -16 * FIX64( 1.164 ) + 128 * ( FIX64( 0.391 ) + FIX64( 0.578 ) ) ) );
int64 csc_subB	= MAKEQW( ( 16*FIX64( 1.164 ) + 128* FIX64( 2.031 ) ) );

short filt_cos[] = { 141, 199, -282, -1020, -457, 1078, 1559, 704, -704, -1559, -1078, 457, 1020, 282, -199, -141 };

short filt_sin[] = { -340, 199, 962, 821, -2182, -1525, 364, 1700, 1700, 364, -1525, -2182, 821, 962, 199, -340 };



/*
 * Decode next field of PAL data
 */
#include <stdio.h>
void decodeFrameEsnelColorMMX(unsigned char *Y, unsigned char *u, unsigned char *v, unsigned char *src, int offset, int pitch)
{
    static unsigned int cbPhase, cbHF, cbVF;
    static int i, j, y, vsaturation, cbOdd;

    src += offset;
    GetColorBurstDataMMX(src, &cbPhase, &cbHF, &cbVF, &cbOdd);

    src += getColorBurstWidth();

    cbHF *= 10;
    vsaturation = cbOdd ? -saturation : saturation;

    for (y = 0; y < decHeight; y += 2) {
	GetChromaSamplesMMX(src, cbPhase, cbHF, cbVF, saturation, vsaturation);

	for (i = 0; i < 2; i++) {
	  GetLumaSamplesMMX(src, adjust_luma_level, brightness, contrast);
	  	if (y > 3 && y < 287) {
	  	for (j = 8; j < 376; j++) {
			Y[(y+i)*pitch+j] = scanLuma[j+16];
			if (j%2 == 0) {
				u[(y+i)*pitch/2+j/2] = 
					scanCbU[j/2+8];
				v[(y+i)*pitch/2+j/2] = 
					scanCrV[j/2+8];
			}
		}
	}
	  src += rawWidth;
	}

	cbPhase	+= 2 * cbVF;
    }
}


/*
 * Initialize decoder
 */
void InitializeDecoderMMX()
{
    int i;

    for (i = 0; i < 1024; i++) { 
	short c = (int) (0x7fffffff * cos(i * M_PI / 512.0)) >> 16;
	short s = (int) (0x7fffffff * sin(i * M_PI / 512.0)) >> 16;
	short *v = (short *) &cosin64[i];
	v[0] = s;
	v[1] = c;
	v[2] = c;
	v[3] = ~s;
	cosint[i] = c;
    }
	
    //isInitialized = true;
}



/*
 * Decode single scanline of Raw 8bit samples in PAL format to grayscale
 * luma (Y) samples at half PAL (50%) resolution.
 */
void GetLumaSamplesMMX(unsigned char *src, int lladjust, int brightness, int contrast)
{
    int64 level64;
    int64 contrast64;
    static int64 fw384 = MAKEQW(384 / 4);
    static unsigned char *sl = scanLuma;
    static int dw4 = decWidth/4;

    __asm__ __volatile__ ("movd  %0, %%mm6" : : "m" (contrast));	/* load contrast */
    __asm__ __volatile__ ("pxor  %mm7, %mm7");				/* empty unpack (0) register */

    __asm__ __volatile__ ("movl  %0, %%esi" : : "m" (src));		/* load input pointer */
    __asm__ __volatile__ ("movl  %0, %%edi" : : "m" (sl));		/* load output pointer */

    __asm__ __volatile__ ("movd  %0, %%mm5" : : "m" (brightness));	/* load brightness level */
    __asm__ __volatile__ ("punpcklwd  %mm6, %mm6\n"			/* unpack contrast into WORD's */

			  "movq  (%esi), %mm0\n"			/* L0: load samples 0..7 */
			  "punpckldq  %mm6, %mm6");			/* unpack contrast into DWORD's */

    __asm__ __volatile__ ("movl  %0, %%eax" : : "m" (lladjust));	/* load scan adjustment BOOL */
    __asm__ __volatile__ ("punpcklwd  %mm5, %mm5\n"			/* unpack brightness level into WORD's */

			  "orl  %eax, %eax\n"				/* luma level scan adjustment ? */
			  "jz  __adjusted");				/* skip luma adjustment if false */


    /* ADJUST BRIGHTNESS TO COLOR BURST */
    			    
    /* {mm1, mm2, mm3, mm4} are free */
    /* {mm6} is contrast */
    /* {mm5} is brightness */
  
    __asm__ __volatile__ ("movq  -168(%esi), %mm1\n"			/* load luma level samples 0..7 */

			  "movq  %mm1, %mm2\n"				/* copy for samples 4..7 */
			  "punpcklbw  %mm7, %mm1\n"			/* unpack samples 0..3 into WORD's */

			  "movq  -176(%esi), %mm3\n"			/* load luma level samples 8..15 */
			  "punpckhbw  %mm7, %mm2\n"			/* unpack samples 4..7 into WORD's */

			  "paddw  %mm2, %mm1\n"				/* add samples --> 0..3 */
			  "movq  %mm3, %mm4\n"				/* copy for samples 12..15 */

			  "movq  -184(%esi), %mm2\n"			/* load luma level samples 16..23 */
			  "punpcklbw  %mm7, %mm3\n"			/* unpack samples 8..11 into WORD's */

			  "paddw  %mm3, %mm1\n"				/* add samples --> 0..3 */
			  "punpckhbw  %mm7, %mm4\n"			/* unpack samples 12..15 into WORD's */

			  "movq  %mm2, %mm3\n"				/* copy for samples 20..23 */
			  "punpcklbw %mm7, %mm2\n"			/* unpack samples 16..19 into WORD's */

			  "punpckhbw  %mm7, %mm3\n"			/* unpack samples 20..23 into WORD's */
			  "paddw  %mm4, %mm1\n"				/* add samples --> 0..3 */

			  "movq  -192(%esi), %mm4\n"			/* load luma level samples 24..31 */
			  "paddw  %mm2, %mm1\n"				/* add samples --> 0..3 */

			  "movq  %mm4, %mm2\n"				/* copy for samples 28..31 */
			  "punpcklbw  %mm7, %mm4\n"			/* unpack samples 24..27 into WORD's */

			  "paddw  %mm3, %mm1\n"				/* add samples --> 0..3 */
			  "punpckhbw %mm7, %mm2");			/* unpack samples 28..31 into WORD's */

    __asm__ __volatile__ ("movq  %0, %%mm3" : : "m" (fw384));		/* load constant '384' (4 x WORD) */
    __asm__ __volatile__ ("paddw  %mm4, %mm1\n"				/* add samples --> 0..3 */

			  /* 11CLK's (non-pairing instructions) */
			  "paddw  %mm2, %mm1\n"				/* add samples --> 0..3 */
			  "psubw  %mm1, %mm3\n"				/*  (384 - cbluma32) */
			  "pmaddwd  %mm6, %mm3\n"			/*  (384 - cbluma32) * contrast */
			  "psrad  $11, %mm3\n"				/* ((384 - cbluma32) * contrast) >> 11 */
			  "punpckldq  %mm3, %mm1\n"			/* put low part of mm3 in high part of mm1 */
			  "paddd  %mm1, %mm3\n"				/* add low part to high part */
			  "punpckhdq  %mm3, %mm3\n"			/* copy luminance adjustment as DWORD's */
			  "packssdw  %mm3, %mm3\n"			/* pack luminance adjustment into WORD's */
			  "paddw  %mm3, %mm5");				/* adjust brightness to color burst */


    /*   FILTER LUMINANCE DATA */
    __asm__ __volatile__ ("__adjusted:\n"
			  "movq  %%mm6, %0" : "=m" (contrast64));	/* #store contrast (4 x WORD) */
    __asm__ __volatile__ ("punpckldq  %mm5, %mm5");			/* #unpack brightness level into DWORD's */

    __asm__ __volatile__ ("movq  %%mm5, %0" : "=m" (level64));		/* #store brightness level (4 x WORD) */
    __asm__ __volatile__ ("movq  %mm0, %mm1");				/* L0: copy for samples 4..7 */

    __asm__ __volatile__ ("movl  %0, %%ecx" : : "m" (dw4));		/* load 4-sample counter */
    __asm__ __volatile__ ("punpcklbw  %mm7, %mm0\n"			/* L0: unpack samples 0..3 */

			  "movq  5(%esi), %mm2\n"			/* L1: load samples 0..7 */
			  "punpckhbw  %mm7, %mm1\n"			/* L0: unpack samples 4..7 */

			  "paddw  %mm1, %mm0\n"				/* L0: add samples --> 0..3 */
			  "movq  %mm2, %mm3\n"				/* L1: copy for samples 4..7 */

			  "punpcklbw  %mm7, %mm2\n"			/* L1: unpack samples 0..3 */
			  "movq  %mm0, %mm1\n"				/* L01: copy of samples L0 */

			  "movq  10(%esi), %mm4\n"			/* L2: load samples 0..7 */
			  "punpckhbw  %mm7, %mm3\n"			/* L1: unpack samples 4..7 */

			  "__pixel:\n"
			  "paddw  %mm3, %mm2\n"				/* L1: add samples --> 0..3 */
			  "movq  %mm4, %mm5\n"				/* L2: copy for samples 4..7 */

			  "movq  15(%esi), %mm6\n"			/* L3: load samples 0..7 */
			  "punpckldq  %mm2, %mm0\n"			/* L01: unpack samples 0..1 of L0, L1 */

			  "punpckhdq  %mm2, %mm1\n"			/* L01: unpack samples 2..3 of L0, L1 */
			  "movq  %mm6, %mm3\n"				/* L3: copy for samples 4..7 */

			  "paddw  %mm1, %mm0\n"				/* L01: add samples --> 0..1 */
			  "punpcklbw  %mm7, %mm4");			/* L2: unpack samples 0..3 */

    __asm__ __volatile__ ("pmaddwd  %0, %%mm0" : : "m" (contrast64));	/* L01: mac samples --> DWORD */
    __asm__ __volatile__ ("punpckhbw  %mm7, %mm5\n"			/* L2: unpack samples 4..7 */

			  "paddw  %mm5, %mm4\n"				/* L2: add samples --> 0..3 */
			  "punpcklbw  %mm7, %mm6\n"			/* L3: unpack samples 0..3 */

			  "movq  %mm4, %mm5\n"				/* L23: copy of samples L2 */
			  "punpckhbw  %mm7, %mm3\n"			/* L3: unpack samples 4..7 */

			  "psrad  $9, %mm0\n"				/* L01: scale samples to normal level */
			  "paddw  %mm3, %mm6\n"				/* L3: add samples --> 0..3 */

			  "punpckldq  %mm6, %mm4\n"			/* L23: unpack samples 0..1 of L2, L3 */
			  "addl  $20, %esi\n"				/* increase input pointer */

			  "punpckhdq  %mm6, %mm5\n"			/* L23: unpack samples 2..3 of L2, L3 */
			  "movq  %mm0, %mm6\n"				/* L01: free MMX register mm0 */

			  "movq  5(%esi), %mm2\n"			/* L1: load samples 0..7 */
			  "paddw  %mm5, %mm4");				/* L23: add samples --> 0..1 */

    __asm__ __volatile__ ("pmaddwd  %0, %%mm4" : : "m"  (contrast64));	/* L23: mac samples --> DWORD */
    __asm__ __volatile__ ("movq  %mm2, %mm3\n"				/* L1: copy for samples 4..7 */

			  "movq  (%esi), %mm0\n"			/* L0: load samples 0..7 */
			  "punpcklbw  %mm7, %mm2\n"			/* L1: unpack samples 0..3 */

			  "movq  %mm0, %mm1\n"				/* L0: copy for samples 4..7 */
			  "punpcklbw  %mm7, %mm0\n"			/* L0: unpack samples 0..3 */

			  "psrad  $9, %mm4\n"				/* L23: scale samples to normal level */
			  "addl  $4, %edi\n"				/* increase output pointer */

			  "packssdw  %mm4, %mm6");			/* L0123: pack samples into WORD's */

    __asm__ __volatile__ ("paddw  %0, %%mm6" : : "m" (level64));	/* L0123: add luminance level */
    __asm__ __volatile__ ("punpckhbw  %mm7, %mm1\n"			/* L0: unpack samples 4..7 */

			  "movq  10(%esi), %mm4\n"			/* L2: load samples 0..7 */
			  "packuswb  %mm6, %mm6\n"			/* L0123: pack samples into UBYTE's */

			  "paddw  %mm1, %mm0\n"				/* L0: add samples --> 0..3 */
			  "punpckhbw  %mm7, %mm3\n"			/* L1: unpack samples 4..7 */

			  "movd  %mm6, -4(%edi)\n"			/* L0123: store output samples 0..3 */
			  "movq  %mm0, %mm1\n"				/* L01: copy of samples L0 */

			  "decl  %ecx\n"				/* decrease 4-sample counter */
			  "jnz  __pixel\n"				/* do {...} while (counter > 0); */

			  "emms");
}


/*
 * Decode single scanline of Raw 8bit samples in PAL format to chroma (U,V)
 * samples at half resolution.
 */
void GetChromaSamplesMMX(unsigned char *src, unsigned int cbPhase, unsigned int cbHF, unsigned int cbVF, int saturation, int vsaturation)
{
    
    int64 invertv64, saturation64;
    int64 *prev = prevScan;
    static char *su = scanCbU;
    static char *sv = scanCrV;
    static int dw2 = decWidth/2;

    __asm__ __volatile__ ("movd  %0, %%mm0" : : "m" (saturation));
    __asm__ __volatile__ ("pcmpeqd  %mm1, %mm1");

    __asm__ __volatile__ ("mov  %0, %%esi" : : "m" (src));		/* load input pointer */
    __asm__ __volatile__ ("psllq  $32, %mm1");
    
    __asm__ __volatile__ ("punpckldq  %0, %%mm0" : : "m" (vsaturation));

    __asm__ __volatile__ ("movq  %%mm1, %0" : "=m" (invertv64));
    __asm__ __volatile__ ("pxor  %mm1, %mm0");

    __asm__ __volatile__ ("movl  %0, %%edx" : : "m" (cbPhase));		/* load color burst phase */
    __asm__ __volatile__ ("pslld  $16, %%mm0\n"

			  "movl  %0, %%ebx\n"				/* load chrominance U pointer */
			  "movl  %1, %%edi" : : "m" (su), "m" (sv));	/* load chrominance V pointer */

    __asm__ __volatile__ ("movq  %%mm0, %0" : "=m" (saturation64));

    
    
    /* DECODE CHROMINANCE COMPONENT OF PAL */
    /* {esi} is source, {edx} is cbPhase */
    /* {ebx} is CbU[], {edi} is CbV */
    
    __asm__ __volatile__ ("movl  %0, %%ecx" : : "m" (dw2));		/* load 2-pixel counter */

    __asm__ __volatile__ ("movq  -7(%esi), %mm0\n"			/* C0: load samples 0..7 */
			  "pxor  %mm7, %mm7\n"				/* empty unpack (0) register */

			  "movq  1(%esi), %mm2\n"			/* C0: load samples 8..15 */
			  "movq  %mm0, %mm1\n"				/* C0: copy for samples 4..7 */

			  "movq  %mm2, %mm3\n"				/* C0: copy for samples 12..15 */
			  "punpcklbw  %mm7, %mm0\n"			/* C0: unpack samples 0..3 into WORD's */

			  "movq  %mm0, %mm4\n"				/* C0: copy of samples 0..3 for "sine" filter */
			  "punpckhbw  %mm7, %mm1");			/* C0: unpack samples 4..7 into WORD's */

    __asm__ __volatile__ ("pmaddwd  (%0), %%mm0" : : "m" (*filt_cos));		/* C0: "cosine" filter samples 0..3 */
    __asm__ __volatile__ ("movq  %mm1, %mm5");				/* C0: copy of samples 4..7 for "sine" filter */

    __asm__ __volatile__ ("pmaddwd  (%0 + 8), %%mm1" : : "m" (*filt_cos));	/* C0: "cosine" filter samples 4..7 */
    __asm__ __volatile__ ("punpcklbw  %mm7, %mm2");			/* C0: unpack samples 8..11 */

    __asm__ __volatile__ ("pmaddwd  (%0), %%mm4" : : "m" (*filt_sin));		/* C0: "sine" filter samples 0..3 */
    __asm__ __volatile__ ("movq  %mm2, %mm6");				/* C0: copy of samples 8..11 for "sine" filter */

    __asm__ __volatile__ ("__pixel_2:\n"
			  "pmaddwd  (%0 + 16), %%mm2" : : "m" (*filt_cos));	/* C0: "cosine" filter samples 8..11 */
    __asm__ __volatile__ ("punpckhbw  %mm7, %mm3");			/* C0: unpack samples 12..15 */

    __asm__ __volatile__ ("pmaddwd  (%0 + 8), %%mm5" : : "m" (*filt_sin));	/* C0: "sine" filter samples 4..7 */
    __asm__ __volatile__ ("paddd  %mm1, %mm0");				/* C0: add "cosine" filtered samples 0..7 */

    __asm__ __volatile__ ("pmaddwd  (%0 + 16), %%mm6" : : "m" (*filt_sin));	/* C0: "sine" filter samples 8..11 */
    __asm__ __volatile__ ("movq  %mm3, %mm1");				/* C0: copy of samples 12..15 for "sine" filter */

    __asm__ __volatile__ ("pmaddwd  (%0 + 24), %%mm3" : : "m" (*filt_cos));	/* C0: "cosine" filter samples 12..15 */
    __asm__ __volatile__ ("paddd  %mm2, %mm0");				/* C0: add "cosine" filtered samples 0..11 */

    __asm__ __volatile__ ("pmaddwd  (%0 + 24), %%mm1" : : "m" (*filt_sin));	/* C0: "sine" filter samples 12..15 */
    __asm__ __volatile__ ("paddd  %mm5, %mm4\n"				/* C0: add "sine" filtered samples 0..7 */

			  "paddd  %mm6, %mm4\n"				/* C0: add "sine" filtered samples 0..11 */
			  "movl  %edx, %eax\n"				/* copy of color burst phase */

			  "paddd  %mm3, %mm0\n"				/* C0: add "cosine" filtered samples 0..15 */
			  "shrl  $22, %eax\n"				/* (cb >> 22) ... index into (co)sine table */

			  "paddd  %mm1, %mm4\n"				/* C0: add "sine" filtered samples 0..15 */
			  "punpckldq  %mm0, %mm3\n"			/* C0: copy low part "cosine" into high part mm3 */

			  "punpckldq  %mm4, %mm1\n"			/* C0: copy low part "sine" into high part mm1 */
			  "paddd  %mm0, %mm3");				/* C0: "cosine" filtered data in high DWORD */

/*    __asm__ __volatile__ ("movq  %0(%%esi), %%mm0" : : "n" (rawWidth - 7));	// C1: load samples 0..7 */
    __asm__ __volatile__ ("movq  2261(%esi), %mm0");			/* C1: load samples 0..7 */
    __asm__ __volatile__ ("paddd  %mm4, %mm1");				/* C0: "sine" filtered data in high DWORD */

/*    __asm__ __volatile__ ("movq  %0(%%esi), %%mm2" : : "n" (rawWidth + 1));	// C1: load samples 8..15 */
    __asm__ __volatile__ ("movq  2269(%esi), %mm2");			/* C1: load samples 8..15 */
    __asm__ __volatile__ ("punpckhdq  %mm1, %mm3\n"			/* C0: low DWORD={cosine}, high DWORD={sine} */

			  "psrad  $12, %mm3\n"				/* C0: scale (co)sine filtered data */
			  "movq  %mm0, %mm1\n"				/* C1: copy for samples 4..7 */

			  "packssdw  %mm3, %mm3\n"			/* C0: pack co(sine) filtered data into WORD's */
			  "movq  %mm2, %mm6");				/* C1: copy for samples 12..15 */

    __asm__ __volatile__ ("pmaddwd  %0(, %%eax, 8), %%mm3" : : "m" (*cosin64));	/* C0: low DWORD={u}, high DWORD={v} */
    __asm__ __volatile__ ("punpcklbw  %mm7, %mm0\n"			/* C1: unpack samples 0..3 into WORD's */

			  "movq  %mm0, %mm4\n"				/* C1: copy of samples 0..3 for "sine" filter */
			  "punpckhbw  %mm7, %mm1");			/* C1: unpack samples 4..7 into WORD's */

    __asm__ __volatile__ ("pmaddwd  (%0), %%mm0" : : "m" (*filt_cos));		/* C1: "cosine" filter samples 0..3 */
    __asm__ __volatile__ ("movq  %mm1, %mm5");				/* C1: copy of samples 4..7 for "sine" filter */

    __asm__ __volatile__ ("pmaddwd  (%0 + 8), %%mm1" : : "m" (*filt_cos));	/* C1: "cosine" filter samples 4..7 */
    __asm__ __volatile__ ("punpcklbw  %mm7, %mm2");			/* C1: unpack samples 8..11 */

    __asm__ __volatile__ ("pmaddwd  (%0), %%mm4" : : "m" (*filt_sin));		/* C1: "sine" filter samples 0..3 */
    __asm__ __volatile__ ("punpckhbw  %mm7, %mm6");			/* C1: unpack samples 12..15 */

    __asm__ __volatile__ ("pmaddwd  (%0 + 8), %%mm5" : : "m" (*filt_sin));	/* C1: "sine" filter samples 4..7 */
    __asm__ __volatile__ ("movq  %mm2, %mm7");				/* C1: copy of samples 8..11 for "sine" filter */

    __asm__ __volatile__ ("pmaddwd  (%0 + 16), %%mm2" : : "m" (*filt_cos));	/* C1: "cosine" filter samples 8..11 */
    __asm__ __volatile__ ("paddd  %mm1, %mm0");				/* C1: add "cosine" filtered samples 0..7 */

    __asm__ __volatile__ ("pmaddwd  (%0 + 16), %%mm7" : : "m" (*filt_sin));	/* C1: "sine" filter samples 8..11 */
    __asm__ __volatile__ ("movq  %mm6, %mm1");				/* C1: copy of samples 12..15 for "sine" filter */

    __asm__ __volatile__ ("pmaddwd  (%0 + 24), %%mm6" : : "m" (*filt_cos));	/* C1: "cosine" filter samples 12..15 */
    __asm__ __volatile__ ("paddd  %mm2, %mm0");				/* C1: add "cosine" filtered samples 0..11 */

    __asm__ __volatile__ ("pmaddwd  (%0 + 24), %%mm1" : : "m" (*filt_sin));	/* C1: "sine" filter samples 12..15 */
    __asm__ __volatile__ ("paddd  %mm5, %mm4\n"				/* C1: add "sine" filtered samples 0..7 */

			  "paddd  %mm7, %mm4");				/* C1: add "sine" filtered samples 0..11 */
    __asm__ __volatile__ ("movl  %0, %%eax" : : "m" (cbVF));		/* load color burst vertical stepsize */

    __asm__ __volatile__ ("paddd  %mm6, %mm0\n"				/* C1: add "cosine" filtered samples 0..15 */
			  "addl  %edx, %eax\n"				/* copy of color burst phase */

			  "paddd  %mm1, %mm4\n"				/* C1: add "sine" filtered samples 0..15 */
			  "shrl  $22, %eax");				/* (cb >> 22) ... index into (co)sine table */

    __asm__ __volatile__ ("pxor  %0, %%mm3" : : "m" (invertv64));	/* C0: invert chrominace "V" (feature of PAL) */
    __asm__ __volatile__ ("punpckldq  %mm0, %mm5\n"			/* C1: copy low part "cosine" into high part mm5 */

			  "punpckldq  %mm4, %mm7\n"			/* C1: copy low part "sine" into high part mm7 */
			  "paddd  %mm0, %mm5\n"				/* C1: "cosine" filtered data in high DWORD */

			  "paddd  %mm4, %mm7\n"				/* C1: "sine" filtered data in high DWORD */
			  "incl  %ebx");				/* increase chrominance "U" pointer */

    __asm__ __volatile__ ("movq  %0(, %%eax, 8), %%mm6" : : "m" (*cosin64));	/* load (co)sine table entry */
    __asm__ __volatile__ ("punpckhdq  %mm7, %mm5");			/* C1: low DWORD={cosine}, high DWORD={sine} */

    __asm__ __volatile__ ("movl %0, %%eax" : : "m" (prev));		/* previous scanline chrominance pointer */
    __asm__ __volatile__ ("psrad  $12, %mm5\n"				/* C1: scale (co)sine filtered data */

			  "incl %edi\n"					/* increase chrominance "V" pointer */
			  "packssdw %mm5, %mm5\n"			/* C1: pack co(sine) filtered data into WORD's */

			  "pmaddwd  %mm6, %mm5\n"			/* C1: low DWORD={u}, high DWORD={v} */
			  "movq  (%eax), %mm6\n"			/* load previous scanline chrominance samples */

			  "addl  $8, %eax\n"				/* increase previous chrominance pointer */
			  "addl  $10, %esi\n"				/* increase input pointer */

			  "pxor  %mm7, %mm7");				/* empty unpack (0) register */
    __asm__ __volatile__ ("movl  %%eax, %0" : "=m" (prev));		/* store previous chrominance pointer */

    __asm__ __volatile__ ("movq  -7(%esi), %mm0\n"			/* C0: load samples 0..7 */
			  "paddd  %mm3, %mm5\n"				/* C01: low DWORD={u}, high DWORD={v} */

			  "movq  1(%esi), %mm2\n"			/* C0: load samples 8..15 */
			  "paddd  %mm5, %mm6");				/* average chrominance scanlines (PAL feature) */

    __asm__ __volatile__ ("pmaddwd  %0, %%mm6" : : "m" (saturation64)); /* adjust saturation levels */
    __asm__ __volatile__ ("movq  %mm0, %mm1\n"				/* C0: copy for samples 4..7 */

			  "movq  %mm5, -8(%eax)\n"			/* store current scanline chrominance samples */
			  "movq  %mm2, %mm3");				/* C0: copy for samples 12..15 */

    __asm__ __volatile__ ("movl  %0, %%eax" : : "m" (cbHF));		/* load color burst horizontal stepsize */
    __asm__ __volatile__ ("punpcklbw  %mm7, %mm0\n"			/* C0: unpack samples 0..3 into WORD's */

			  "psrad  $7, %mm6\n"				/* scale chroma output samples */
			  "addl  %eax, %edx\n"				/* increment color burst phase (H) */

			  "movq  %mm0, %mm4\n"				/* C0: copy of samples 0..3 for "sine" filter */
			  "packssdw  %mm6, %mm6");			/* pack chroma output samples into WORD's */

    __asm__ __volatile__ ("pmaddwd  (%0), %%mm0" : : "m" (*filt_cos));	/* C0: "cosine" filter samples 0..3 */
    __asm__ __volatile__ ("packsswb  %mm6, %mm6");			/* pack chroma output samples into BYTE's */

    __asm__ __volatile__ ("pmaddwd  (%0), %%mm4" : : "m" (*filt_sin));	/* C0: "sine" filter samples 0..3 */
    __asm__ __volatile__ ("punpckhbw  %mm7, %mm1\n"			/* C0: unpack samples 4..7 into WORD's */

			  "movd  %mm6, %eax\n"				/* copy of chroma output samples */
			  "movq  %mm1, %mm5");				/* C0: copy of samples 4..7 for "sine" filter */

    __asm__ __volatile__ ("pmaddwd  (%0 + 8), %%mm1" : : "m" (*filt_cos));	/* C0: "cosine" filter samples 4..7 */
    __asm__ __volatile__ ("punpcklbw  %mm7, %mm2\n"			/* C0: unpack samples 8..11 */

			  "xorl  $0x8080, %eax\n"			/* chroma signed to unsigned conversion */
			  "movq  %mm2, %mm6\n"				/* C0: copy of samples 8..11 for "sine" filter */
			 
			  "movb  %al, -1(%ebx)\n"			/* store sample U (blue) */
			  "movb  %ah, -1(%edi)\n");			/* store sample V (red) */
    
    __asm__ __volatile__ ("decl  %ecx\n"				/* decrease chrominance sample counter */
			  "jnz  __pixel_2\n"				/* do {...} while (counter > 0); */

			  "emms");
}


/*  Todo :  optimize this (MMX) ... */
/*
 * Get color burst information
 */
void GetColorBurstDataMMX(unsigned char *src, unsigned int *cbPhase, unsigned int *cbHF, unsigned int *cbVF, int* cbOdd)
{
    static int cbPhases[decHeight];
    double f_amp, div;
    unsigned int c0, c1, s0, s1, p0, p1, p2, p3, f_cb;
    int i, v, x, y, f_cos, f_sin;


    /* determine phase offsets of colorburst */
    for (y=0; y < decHeight; y++) {
	for (x=0, f_cos=0, f_sin=0, f_cb=0; x < 72; x++) {
	    i      = *src++;
	    f_cos += cosint[ f_cb               >> 22] * i;
	    f_sin += cosint[(f_cb - 0x40000000) >> 22] * i;
	    f_cb  += FcHF0;
	}
	src  += (rawWidth - 72);

	div = sqrt( (double) f_cos*f_cos + (double) f_sin*f_sin );
	if (div != 0)
	    f_amp = 1 / div;
	else
	    f_amp = 10000;

	c1 = (unsigned int) (acos( f_cos * f_amp ) * divPi);
	s0 = (unsigned int) (asin( f_sin * f_amp ) * divPi) + 0x80000000;
	c0 = ~c1;
	s1 = ~s0 + 0x80000000;
	p0 = abs(c0 - s0);  p1 = abs(c0 - s1);
	p2 = abs(c1 - s0);  p3 = abs(c1 - s1);

	if ((p0 < p2 && p0 < p3) || (p1 < p2 && p1 < p3))  c1 = c0;
	if ((p0 < p1 && p0 < p3) || (p2 < p1 && p2 < p3))  s1 = s0;

	cbPhases[y] = (s1 >> 1) + (c1 >> 1);
    }

    /* Vc polarity detection  (even/odd frame) */
    for (i=2, p0=0, p1=0; i < (decHeight - 2); i += 2) {
	p0 += abs( cbPhases[i] - cbPhases[i - 1] ) >> 8;
	p1 += abs( cbPhases[i + 1] - cbPhases[i] ) >> 8;
    }
    *cbOdd = (p0 < p1)?1:0;

    /* sample rate correction (color burst) */
    for (i=8, v=0; i < (decHeight /2); i++) {
	v += (cbPhases[(decHeight /2) + i] - cbPhases[i]) >> 8;
    }
    
    v		= ((v /(decHeight /2)) << 8) /((decHeight /2) - 8);
    *cbHF	= v /rawWidth +  FcHF0;
    *cbVF	= v           +  FcVF0;
    i		= cbPhases[0] +  200 * (*cbHF) - 0x60000000L;
    i	       -= (*cbOdd ? 0 : -0x40000000);
    *cbPhase	=  i - *cbHF - (*cbHF >> 1);
}

static int InvertPolarity()
{
    invert_polarity = !invert_polarity;
    contrast = -contrast;

    if (correct_brightness == 0 && contrast < 0) {
        brightness += method->bright_adjust;
        correct_brightness = 1;
    } else if (correct_brightness == 1 && contrast > 1) {
        brightness -= method->bright_adjust;
        correct_brightness = 0;
    }

    return invert_polarity;
}


static int InvertChroma()
{
    invert_chroma = !invert_chroma;
    saturation = -saturation;

    return invert_chroma;
}

void setPolarity(int pol) {
	if (invert_polarity == pol) return;
	InvertPolarity();
}

void setChroma(int chr) {
	if (invert_chroma == chr) return;
	InvertChroma();
}


